//FILE: main.cpp (systemc)
//# vim600:set sw=2 tw=0 fdm=marker:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//See wave.h for more information
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <iostream>
using std::cout;
using std::endl;

#include <systemc.h>
#include "wave.h"

unsigned errors = 0;
char* simulation_name = "wave";
char* simulation_vers = "$Header: /eklectICally/Project/ea/Cvsroot/Book2003/Examples/wave/main.cpp,v 1.1 2004/02/29 04:41:14 dcblack Exp $";

int sc_main(int argc, char* argv[]) {
    cout << "INFO: " << simulation_name << " " << simulation_vers << endl;
    cout << "INFO: Elaborating "<< simulation_name << endl;
    sc_set_time_resolution(1,SC_PS);
    sc_set_default_time_unit(1,SC_NS);
    wave wave_i("wave_i");
    cout << "INFO: Simulating "<< simulation_name << endl;
    sc_start();
    cout << "INFO: Post-processing "<< simulation_name << endl;
    cout << "INFO: Simulation " << simulation_name
        << " " << (errors?"FAILED":"PASSED")
        << " with " << errors << " errors"
        << endl;
    return errors?1:0;
}

//Portions COPYRIGHT (C) 2003-2004 Eklectic Ally, Inc.-------------{{{//
// Permission granted for anybody to use this example provided this   //
// acknowledgement of Eklectic Ally, Inc. remains.                    //
//-----------------------------------------------------------------}}}//
//END $Id: main.cpp,v 1.1 2004/02/29 04:41:14 dcblack Exp $
